SystemOrganization addCategory: #'Either-Tests'!
SystemOrganization addCategory: #Either!

TestCase subclass: #EitherTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Either-Tests'!

!EitherTest methodsFor: 'testing - monad' stamp: 'fbs 7/1/2011 14:08'!
testBindToLeftReturnsLeft
	self deny: ((Left value: 1) >>= [:x | Right value: x]) isRight.
	self deny: ((Left value: 1) >>= [:x | Left value: x]) isRight.! !

!EitherTest methodsFor: 'testing - monad' stamp: 'fbs 7/1/2011 14:08'!
testBindToRightReturnsDeeperValue
	self deny: ((Right value: 1) >>= [:x | Left value: x]) isRight.
	
	self assert: ((Right value: 1) >>= [:x | Right value: 2]) isRight.
	self assert: ((Right value: 1) >>= [:x | Right value: 2]) value = 2.! !

!EitherTest methodsFor: 'testing - monad' stamp: 'fbs 7/1/2011 13:57'!
testReturnReturnsaRight
	self assert: (Either return: 1) isRight.! !

TestCase subclass: #LeftTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Either-Tests'!

!LeftTest methodsFor: 'testing - testing' stamp: 'fbs 7/1/2011 14:01'!
testLeftIsNotRight
	self deny: (Left value: 1) isRight! !

TestCase subclass: #RightTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Either-Tests'!

!RightTest methodsFor: 'testing - testing' stamp: 'fbs 7/1/2011 14:00'!
testRightIsRight
	self assert: (Right value: 1) isRight.! !

Object subclass: #Either
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Either'!

!Either class methodsFor: 'monad' stamp: 'fbs 7/1/2011 13:56'!
return: anObject
	^ Right value: anObject! !

!Either class methodsFor: 'instance creation' stamp: 'fbs 7/1/2011 13:51'!
value: anObject
	^ self new value: anObject! !

!Either methodsFor: 'testing' stamp: 'fbs 7/1/2011 13:57'!
isRight
	self subclassResponsibility! !

!Either methodsFor: 'accessing' stamp: 'fbs 7/1/2011 13:50'!
value
	^ value! !

!Either methodsFor: 'private' stamp: 'fbs 7/1/2011 13:51'!
value: anObject
	value := anObject.! !

Either subclass: #Left
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Either'!

!Left methodsFor: 'monad' stamp: 'fbs 7/1/2011 14:04'!
>>= anEitherReturningUnaryBlock
	^ self.! !

!Left methodsFor: 'testing' stamp: 'fbs 7/1/2011 13:55'!
isRight
	^ false.! !

Either subclass: #Right
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Either'!

!Right methodsFor: 'monad' stamp: 'fbs 7/1/2011 14:07'!
>>= anEitherReturningUnaryBlock
	^ anEitherReturningUnaryBlock value: value! !

!Right methodsFor: 'testing' stamp: 'fbs 7/1/2011 13:57'!
isRight
	^ true.! !
